var
{
	CurseWords[]
}

proc
{
	SaveFilter()
	{
		var/savefile/F
		var/M
		F = new("filter.dat")
		F << CurseWords.len
		for(M in CurseWords)
			F << M
	}

	LoadFilter()
	{
		var/savefile/F
		var/length
		var/i
		var/M
		F = new("filter.dat")
		F >> length
		if(length)
			for(i = 0,i < length,i++)
				F >> M
				CurseWords += M
	}

	InitFilter()
	{
		CurseWords = new /list/
		LoadFilter()
	}

	AddWord(word as text)
	{
		CurseWords += word
	}

	RemoveWord(word in CurseWords)
	{
		CurseWords -= word
	}

	FilterString(msg as text)
	{
		var/i
		var/pos
		var/CurseLen
		if(CurseWords.len)
			for(i = 1,i < CurseWords.len + 1,i++)
				pos = findtext(msg,CurseWords[i])
				while(pos)
					CurseLen = length(CurseWords[i])
					msg = copytext(msg,1,pos) + GenSymbols(CurseLen) + copytext(msg,pos+CurseLen,0)
					pos = findtext(msg,CurseWords[i])



		return msg
	}

	GenSymbols(length as num)
	{
		var/T
		var/i
		for(i = 0,i < length,i++)
			T += pick("!","@","#","$","%","^","&","*")

		return T
	}
}